<template>
	<div class="p-20 messages-wrapper">
		<div class="p-bottom-20 d-flex flex-direction-columns">
			<input type="text" class="input border" placeholder="Search for mail..." v-model="pattern" @input="filterMessages()">

			<div class="messages-list m-top-20 box-shadow" v-if="messages.length">
				<ul class="p-0">
					<li class="p-20 border messages-list-item" v-for="(message, index) in messages" :key="index" 
						@click="$store.commit('getMessage', message)">
						<p class="text-right m-bottom-10">
							{{ message.timestamp | timestamp }}
						</p>

						<h4 class="word-break">{{ message.from }}</h4>

						<p class="p-top-40 p-bottom-10 word-break">
							{{ message.subject | substring(70) }}
						</p>

						<p class="text-grey word-break">
							{{ message.body | substring(70) }}
						</p>
					</li>
				</ul>

				<div class="text-right text-grey p-top-10 bg-white total-messages w-100">
					<span class="p-right-20">Showing {{ messages.length }} of {{ count }} mails</span>
				</div>
			</div>

			<div class="alert" v-else>
				No messages !
			</div>
		</div>
	</div>
</template>
<script>

import response from '../assets/messages.json'

export default {

	data() {

		return {

			data: response,

			messages: [],

			pattern: '',

			// Fake total count emails
			count: 235,

			// Fake pagination
			take: 10,

			skip: 0
		}
	},

	async mounted() {

		// Initial messages load
		this.getMessages('inbox')

		// Watch status change of the messages from the sidebar
		this.unwatch = this.$store.watch((state, getters) => getters.status, status => {
			
			this.getMessages(status)
		})

		// Load more messages when user scrolls to bottom of the element
		this.$nextTick(() => {	

			document.querySelector('.messages-list').addEventListener('scroll', event => {

				if(event.target.scrollTop + event.target.offsetHeight >= event.target.scrollHeight) {

					// this.getMessages(status)
				}
			})
		})
	},

	methods: {

		getMessages(status) {

			// API example
			// update pagination before call
			// this.skip += this.take
			
			// axios.get('/api/messages/list', { 

				// status: status,

				// take: this.take,

				// skip: this.skip

			// }).then(response => { 

				// Get total count of the model if api provides it
				// this.count = response.data?.count

				// Get messages
				// this.messages = this.messages.contact(response.data.messages) 

				// Get messages
				this.messages = this.data[status]

				// Store messages
				this.$store.commit('getMessages', this.messages)

				// Select first for display
				this.$store.commit('getMessage', this.messages[0])

			// })
		},

		// Probably backend call to db instead of javascript search
		// search all messages even that ones that are not loaded yet.
		filterMessages() {

			if(this.pattern != '') {

				let result = []

				// There are cleaner iterators than the good old for loop
				// but it is still the fastest way to go through an array
				for(let i = 0; i < this.$store.state.messages.length; i++) {

					// Search through all attributes of the object
					for(const [key, value] of Object.entries(this.$store.state.messages[i])) {

						// Skip true/false values and search the pattern 
						if(typeof value !== 'boolean' && value.toLowerCase().search(this.pattern.toLowerCase()) != -1) {

							result.push(this.$store.state.messages[i])
						}
					}
				}
				
				// Get searched query
				this.messages = result

				// Select first for display
				this.$store.commit('getMessage', this.messages[0])

			} else {

				// Reset values
				this.messages = this.$store.state.messages
			}
		}
	}
}

</script>

<style scoped>

.messages-wrapper > div {
	height: calc(100% - 20px);
}

.messages-list {
	height: calc(100% - 60px);
	position: relative;
}

.messages-list > ul {
	max-height: calc(100vh - 220px); 
	overflow-y: auto;
	list-style: none;
}

.messages-list-item {
	overflow: hidden;
}

.messages-list-item:nth-child(even) {
	border-top: 0px;
	border-bottom: 0px;
} 

.messages-list-item:nth-last-child(1) {
	border-bottom: 2px solid #dedede;
}

.messages-list-item:hover {
    background-color: rgb(233, 233, 233);
    cursor: pointer;
}

.alert {
	background-color: #E9E9E9;
	border: 2px solid #E9E9E9;
	padding: 10px;
	margin-top: 20px;
	border-radius: 5px;
}

.total-messages {
	position: absolute;
	bottom: 5px;
	right: 0px
}

</style>